﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _01_AdattablakNativKezelese.Adatbazis.Kezelok
{
    class BaseDatabaseManager
    {
        protected BaseDatabaseManager() { }

        // MSSQL adatbázisok esetén az adatbázissal való
        // kommunikáció SqlConnection példányon keresztül
        // történik
        protected SqlConnection getConnection()
        {
            // 1) Sqlconnection példány létrehozása
            SqlConnection connection = new SqlConnection();

            /*
            // 2) kapcsolati stringet definiálunk
            string connectionString = @"Name = 193.225.33.22;
                                        Intial Catalog = RE1D25_2018_L;
                                        User id = RE1D25;
                                        Password = szelektcsillag;";
            // 3) Állítsuk be conn stringet a kapcsolódás param.
            connection.ConnectionString = connectionString;
             */

            // 2-3) Helyett a param. beolvasását dinamikussá tesszük
            // konfig állományból
            string connectionString = ConfigurationManager.ConnectionStrings["EKE-DB"].ConnectionString;
            connection.ConnectionString = connectionString;

            // 4) Végül visszaadjuk a hívás helyére a pld-t.
            return connection;

            /*
             Ha a kapcs. paraméterei a forrásban szerepelnek, akkor
             azok megváltoztatásához újra kell fordítani a forrást!!
             * => Konfigurációs állományba kell helyezni az paramétereket
             */ 
        }

       /// <summary>
       /// Végrehajtja a DML nyelvi családba tartozó kéréseket (INSERT, UPDATE, DELETE).
       /// </summary>
       /// <param name="command">A végrehajtandó lekérdezésből készített parancs</param>
       /// <returns>A parancs által érintett sorok száma</returns>
        protected int executeDML(SqlCommand command)
        {
            int rowCount = 0;
            try // Azt kezeli, ha a db kapcsolódás során van hiba
            {
                SqlConnection connection = getConnection();
                connection.Open();

                try // Azt kezeli, ha a command végrehajtása során van hiba
                {
                    command.Connection = connection;
                    rowCount = command.ExecuteNonQuery();
                }
                catch { }
                finally { connection.Close(); }
            }
            catch { }

            return rowCount;
        }

        protected DataTable executeQL()
        {
            throw new NotImplementedException();
        }
    }
}
