﻿using _01_AdattablakNativKezelese.Adatbazis.Rekordok;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _01_AdattablakNativKezelese.Adatbazis.Kezelok
{
    class TelepulesekTableManager : BaseDatabaseManager
    {
        public List<Telepules> Select()
        {
            List<Telepules> rekordok = new List<Telepules>();
            // command pld készítése
            SqlCommand command = new SqlCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandTimeout = 0;
            command.CommandText = @"SELECT id, irsz, nev, active
                                    FROM telepulesek
                                    ORDER BY nev;";
            
            try
            {
                SqlConnection connection = getConnection();
                connection.Open();
                command.Connection = connection;

                try
                {
                    SqlDataReader reader = command.ExecuteReader();
                    while (reader.Read())
                    {
                        try
                        {
                            Telepules t = new Telepules(long.Parse(reader["id"].ToString()),
                                                        reader["irsz"].ToString(),
                                                        reader["nev"].ToString(),
                                                        (bool)reader["active"]);
                            rekordok.Add(t);
                        }
                        catch { }
                    }
                }
                finally { connection.Close(); }

            }
            catch { }

            return rekordok;
        }

        public Telepules SelectOne(Telepules t)
        {
            Telepules telepules = null;

            SqlCommand command = new SqlCommand();
            command.CommandType = System.Data.CommandType.Text;
            command.CommandTimeout = 0;
            command.CommandText = @"SELECT id, irsz, nev, active 
                                    FROM telepulesek
                                    WHERE id = @id";
            SqlParameter id_parameter = new SqlParameter();
            id_parameter.SqlDbType = System.Data.SqlDbType.Int;
            id_parameter.ParameterName = "@id";
            command.Parameters.Add(id_parameter);

            try
            {
                SqlConnection connection = getConnection();
                connection.Open();
                command.Connection = connection;

                try
                {
                    SqlDataReader reader = command.ExecuteReader();
                    if (reader.Read())
                    {
                        telepules = new Telepules(long.Parse(reader["id"].ToString()),
                                                  reader["irsz"].ToString(),
                                                  reader["nev"].ToString(),
                                                  (bool)reader["active"]);
                    }
                }
                finally { connection.Close(); }
            }
            catch { }

            return telepules;
        }
    }
}
