﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace _01_AdattablakNativKezelese.Adatbazis.Rekordok
{
    class Telepules
    {
        private long id;
        private string irsz;
        private string nev;
        private bool aktiv;

        public long Id
        {
            get { return id; }
            set { id = value; }
        }
        public string Irsz
        {
            get { return irsz; }
            set
            {
                if (value.Length != 4)
                    throw new FormatException("Az irsz hossza nem 4 karakter");

                int szam;
                if (!int.TryParse(value, out szam))
                    throw new FormatException("Az irsz-ben nem csak számjegyek vannak!");

                irsz = value;
            }
        }
        // Amennyiben könnyen ellenőrizhető a rekord formai helyessége, 
        // akkor a set ágakban azt kötelezően ellenőrizni kell. 
        // ==> Feleslegesen ne intézzünk kéréséket az adatbázis felé.
        public string Nev
        {
            get { return nev; }
            set { nev = value; }

        }
        public bool Aktiv
        {
            get { return aktiv; }
            set { aktiv = value; }
        }

        // Az aktív biten keresztül minden adat kötelező
        public Telepules(long id, string irsz, string nev)
        {
            Id = id;
            Irsz = irsz;
            Nev = nev;
        }

        public Telepules(long id, string irsz, string nev, bool aktiv)
            : this(id, irsz, nev)
        {
            Aktiv = aktiv;
        }
    }
}
