﻿using _01_AdattablakNativKezelese.Adatbazis.Kezelok;
using _01_AdattablakNativKezelese.Adatbazis.Rekordok;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace _01_AdattablakNativKezelese
{
    public partial class Form1 : Form
    {
        BackgroundWorker tableList_bgWorker;
        TelepulesekTableManager telepulesek_tableManager;
        public Form1()
        {
            InitializeComponent();

            
          //  List<Telepules> telepulesek = telepulesek_tableManager.Select();
            initDataGridView();
          
        }

        private void initDataGridView()
        {
            // Kitöröljük a sorokat, ha vannak
            dataGridView1.Rows.Clear();
            // Kitöröljük az oszlopokat, ha vannak
            dataGridView1.Columns.Clear();

            DataGridViewTextBoxColumn idColumn = new DataGridViewTextBoxColumn();
            idColumn.HeaderText = "Id";
            idColumn.Name = "id";
            idColumn.Visible = false;

            DataGridViewTextBoxColumn nevColumn = new DataGridViewTextBoxColumn();
            nevColumn.HeaderText = "Név";
            nevColumn.Width = 250;
            nevColumn.AutoSizeMode = DataGridViewAutoSizeColumnMode.None;

            DataGridViewTextBoxColumn irszColumn = new DataGridViewTextBoxColumn();
            irszColumn.HeaderText = "Irányítószám";
            irszColumn.Width = 100;
            irszColumn.AutoSizeMode = DataGridViewAutoSizeColumnMode.None;

            DataGridViewCheckBoxColumn aktivColumn = new DataGridViewCheckBoxColumn();
            aktivColumn.HeaderText = "Aktív?";
            aktivColumn.Width = 100;
            aktivColumn.AutoSizeMode = DataGridViewAutoSizeColumnMode.None;

            dataGridView1.Columns.Add(idColumn);
            dataGridView1.Columns.Add(nevColumn);
            dataGridView1.Columns.Add(irszColumn);
            dataGridView1.Columns.Add(aktivColumn);

            dataGridView1.SelectionChanged += dataGridView1_SelectionChanged;
        }

        private void fillDataGridView()
        {
            System.Threading.Thread.Sleep(10000);

           
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            tableList_bgWorker.RunWorkerAsync();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            telepulesek_tableManager  = new TelepulesekTableManager();
            tableList_bgWorker = new BackgroundWorker();
            tableList_bgWorker.WorkerSupportsCancellation = true;
            tableList_bgWorker.DoWork += tableList_bgWorker_DoWork;
            tableList_bgWorker.RunWorkerCompleted += tableList_bgWorker_RunWorkerCompleted;

            record_bgWorker = new BackgroundWorker();
            record_bgWorker.WorkerSupportsCancellation = true;
            record_bgWorker.DoWork += record_bgWorker_DoWork;
            record_bgWorker.RunWorkerCompleted += record_bgWorker_RunWorkerCompleted;
        }

        void record_bgWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            textBox1.Text = aktualisTelepules.Irsz;
            textBox2.Text = aktualisTelepules.Nev;
            checkBox1.Checked = aktualisTelepules.Aktiv;
        }

        void record_bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            aktualisTelepules = telepulesek_tableManager.SelectOne(aktualisTelepules);
        }

        void tableList_bgWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            dataGridView1.Rows.Clear();
            foreach (Telepules t in list)
            {
                dataGridView1.Rows.Add(new object[] { t.Id, t.Nev, t.Irsz, t.Aktiv});
            }
            textBox1.Text = "Kész!";
        }

        private List<Telepules> list;
        void tableList_bgWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            list = telepulesek_tableManager.Select();
        }

        private BackgroundWorker record_bgWorker;
        private Telepules aktualisTelepules;
        private void dataGridView1_SelectionChanged(object sender, EventArgs e)
        {
            if (dataGridView1.CurrentCell.Value == null || dataGridView1.SelectedRows.Count == 0)
                return;
            aktualisTelepules = list[dataGridView1.CurrentCellAddress.Y];
            record_bgWorker.RunWorkerAsync();

        }
    }
}
